From 428d094b3fe209bd398f1356e81191cedf97951b Mon Sep 17 00:00:00 2001
From: Oliver Ford <oliver.f@argodevops.co.uk>
Date: Wed, 24 Sep 2025 12:53:42 +0100
Subject: [PATCH] Add uint8/uint16 to gen_node_support

---
 src/backend/nodes/gen_node_support.pl | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

diff --git a/src/backend/nodes/gen_node_support.pl b/src/backend/nodes/gen_node_support.pl
index 9ecddb14231..b24713f000b 100644
--- a/src/backend/nodes/gen_node_support.pl
+++ b/src/backend/nodes/gen_node_support.pl
@@ -1030,7 +1030,9 @@ _read${n}(void)
 			print $off "\tWRITE_INT_FIELD($f);\n";
 			print $rff "\tREAD_INT_FIELD($f);\n" unless $no_read;
 		}
-		elsif ($t eq 'uint32'
+		elsif ($t eq 'uint8'
+			|| $t eq 'uint16'
+			|| $t eq 'uint32'
 			|| $t eq 'bits32'
 			|| $t eq 'BlockNumber'
 			|| $t eq 'Index'
-- 
2.43.0